package cz.moneta.test.dsl.cagw.api.v1.external;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.cagw.api.v1.external.product.ProductBuilder;
import cz.moneta.test.dsl.cagw.api.v1.external.service.ServiceBuilder;
import cz.moneta.test.harness.endpoints.cagw.CaGwEndpoint;
import cz.moneta.test.harness.support.rest.Builders;
import cz.moneta.test.harness.support.rest.RestRequest;

public class ExternalBuilder {
    private final Harness harness;

    public ExternalBuilder(Harness harness) {
        this.harness = harness;
    }

    public ProductBuilder product() {
        return new ProductBuilder(harness);
    }

    public ServiceBuilder service() {
        return new ServiceBuilder(harness);
    }

    private <RESP, B extends RestRequest<B, ?, RESP>> B getBuilder(Class<B> builderClass) {
        return Builders.newRestBuilder(builderClass, CaGwEndpoint.class, harness);
    }
}
